MPQC 2.3.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
sc::MP2R12Energy Class Reference

Class MP2R12Energy is the object that computes and maintains MP2-R12 energies. More...

`#include <mp2r12_energy.h>`

Inheritance diagram for sc::MP2R12Energy:
[legend]
Collaboration diagram for sc::MP2R12Energy:
[legend]

## Public Member Functions
| MP2R12Energy (StateIn &)
| MP2R12Energy (Ref< R12IntEval > &r12eval, LinearR12::StandardApproximation stdapp, int debug)
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | obsolete ()
void | print (std::ostream &o=ExEnv::out0()) const
| Print the object.
void | print_pair_energies (bool spinadapted, std::ostream &so=ExEnv::out0())
Ref< R12IntEval > | r12eval () const
LinearR12::StandardApproximation | stdapp () const
bool | gbc () const
| Returns whether Generalized Brillouin Condition (GBC) was used in evaluation of the MP2-R12 intermediates.
bool | ebc () const
| Returns whether Extended Brillouin Condition (EBC) was used in evaluation of the MP2-R12 intermediates and the MP2-R12 energy.
void | set_debug (int debug)
int | get_debug () const
RefSCDimension | dim_aa () const
RefSCDimension | dim_ab () const
RefSCDimension | dim_s () const
RefSCDimension | dim_t () const
void | compute ()
| Computes the first-order R12 wave function and MP2-R12 energy.
double | compute_pair_function_aa (int ij, const SCVector3 &r1, const SCVector3 &r2)
| Computes the value of the alpha-alpha pair function ij when electrons 1 and 2 reside at r1 and r2.
double | compute_pair_function_ab (int ij, const SCVector3 &r1, const SCVector3 &r2)
| Computes the value of the alpha-beta pair function ij when electrons 1 and 2 reside at r1 and r2.
void | compute_pair_function_aa (int ij, const Ref< TwoBodyGrid > &tbgrid)
| Computes values of the alpha-alpha pair function ij on tbgrid.
void | compute_pair_function_ab (int ij, const Ref< TwoBodyGrid > &tbgrid)
| Computes values of the alpha-beta pair function ij on tbgrid.
RefSCVector | emp2_aa () const
| Returns the vector of MP2 alpha-alpha pair energies.
RefSCVector | emp2_ab () const
| Returns the vector of MP2 alpha-beta pair energies.
RefSCVector | er12_aa () const
| Returns the vector of R12 corrections to MP2-R12 alpha-alpha pair energies.
RefSCVector | er12_ab () const
| Returns the vector of R12 correction to MP2-R12 alpha-beta pair energies.
RefSCVector | emp2r12_aa () const
| Returns the vector of MP2-R12 alpha-alpha pair energies.
RefSCVector | emp2r12_ab () const
| Returns the vector of MP2-R12 alpha-beta pair energies.
double | energy ()
| Returns total MP2-R12 correlation energy.
RefSCMatrix | C_aa ()
| Returns the matrix of amplitudes of alpha-alpha r12-multiplied occupied orbital pairs in the first-order pair function.
RefSCMatrix | C_ab ()
| Returns the matrix of amplitudes of alpha-beta r12-multiplied occupied orbital pairs in the first-order pair function.
RefSCMatrix | T2_aa ()
| Returns the matrix of amplitudes of alpha-alpha virtuals orbital pairs in the first-order pair function.
RefSCMatrix | T2_ab ()
| Returns the matrix of amplitudes of alpha-beta virtuals orbital pairs in the first-order pair function.
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members
Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::SavableState
| SavableState (const SavableState &)
| SavableState (StateIn &)
| Each derived class StateIn CTOR handles the restore corresponding to calling save_object_state, save_vbase_state, and save_data_state listed above. More...

## Detailed Description

Class MP2R12Energy is the object that computes and maintains MP2-R12 energies.

## Member Function Documentation

void sc::MP2R12Energy::save_data_state | ( | StateOut & |  | ) |
| virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::SavableState.

The documentation for this class was generated from the following file:

- mp2r12_energy.h